import CryptoJS from 'crypto-js'
import { Base64 } from 'js-base64'
import * as cache from '@/utils/cache'

export default (plugins) => {

  plugins.apply('readNote', (rawNote) => {
    const base64Data = Base64.decode(rawNote)
    const secretKey = cache.get('encrypt_secret')
    if (!secretKey) return base64Data;
  
    const decrypted = CryptoJS.AES.decrypt(base64Data, secretKey)
    return decrypted.toString(CryptoJS.enc.Utf8);
  })
  
  plugins.apply('writeNote', (rawNote) => {
    const secretKey = cache.get('encrypt_secret')
    if (!secretKey) return Base64.encode(rawNote);

    const encrypted = CryptoJS.AES.encrypt(rawNote, secretKey, {
      mode: CryptoJS.mode.CBC,
      padding: CryptoJS.pad.Pkcs7,
    })  
    return Base64.encode(encrypted.toString())
  })
  
}